﻿package 
{
	import fl.controls.Button;
	import fl.controls.ComboBox;
	import fl.controls.Label;
	import fl.controls.TextInput;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	/**
	 * ...
	 * @author ...
	 */
	public class Main extends Sprite 
	{
		
		private var stackList:Array;
		private var diskList:Array;
		private var solver:Solver;
		private var N:uint;
		
		private var btn2:Button;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			drawBar();
			setControls();
			setDiskRandom(N = 8);
		}

		private function onSet(event:MouseEvent):void {
			setDiskRandom(N);			
			btn2.enabled = true;
		}
		
		private function onSolve(event:MouseEvent):void {
			Disk.tweenDelay = 0;
			solver = new Solver(stackList, diskList);			
			solver.solve(N - 1);
			btn2.enabled = false;
		}

		private function getSizeList(n:uint):Array {
			
			Disk.depth = 250 / n;
			
			var sizes:Array = new Array();
			
			for (var i:uint = 0; i < n; i++)
				sizes.push(250 * (i + 1) / n);
			
			return sizes;
//			return arrayShuffle(sizes);
		}
		
		private function arrayShuffle(orgArray:Array):Array {

			var shuffledArray:Array = new Array();
			var i:Number = 0;
			
			while (orgArray.length) {
				var randomNum:Number = Math.floor(Math.random() * orgArray.length);
				shuffledArray.push(orgArray.splice(randomNum, 1));
				i++;
			}
			return shuffledArray;
		}		
		
		private function setDiskRandom(n:uint):void {
			
			for each(var v:Disk in diskList)
				removeChild(v);
			
			stackList = new Array();
			for (var i:uint = 0; i < 3; i++)
				stackList.push(new DiskStack(150 + 250 * i));
			

			var sizeList:Array = getSizeList(n);
			diskList = new Array();
			for (i = 0; i < n; i++ ) {

				var disk:Disk = new Disk(sizeList.pop());
				addChild(disk);
				diskList.push(disk);
				
				stackList[Math.floor(Math.random() * 3)].push(disk);
			}
		}
		
		private function onChange(event:Event):void {
			var cb:ComboBox = event.target as ComboBox;
			N = cb.selectedItem.data;
			onSet(null);
		}
		
		private function setControls():void {
			var cb:ComboBox = new ComboBox();
			cb.move(20, 20);
			cb.prompt = "N =";
			
			for (var i:uint = 2; i < 64 + 1; i++ )
				cb.addItem({label:i.toString(), data:i});
			cb.setSize(50, 20);
			cb.addEventListener(Event.CHANGE, onChange);
			addChild(cb);
						
			var btn:Button = new Button();
			btn.move(90, 20);
			btn.label = "reset";
			btn.setSize(40, 20);
			btn.addEventListener(MouseEvent.CLICK, onSet);
			addChild(btn);
			
			btn2 = new Button();
			btn2.move(140, 20);
			btn2.label = "solve";
			btn2.setSize(40, 20);
			btn2.addEventListener(MouseEvent.CLICK, onSolve);
			addChild(btn2);
			
		}

		
		private function drawBar():void {
			graphics.lineStyle(8, 0xffffff);

			graphics.moveTo(150, 200);
			graphics.lineTo(150, 600);
			
			graphics.moveTo(400, 200);
			graphics.lineTo(400, 600);

			graphics.moveTo(650, 200);
			graphics.lineTo(650, 600);
		}				
	}	
}
